  /* gW - Guenter Wahl:  code imported to have "search a message by "MesageID"
   *     from within ReminderFox Dialog window  
   *
   *  ...............................................................
   *  based on  MessageID-Finder for Mozilla
   *            'messageidfinder-2.0.0.xpi' by markushossner@gmx.de 
   *  and
   *            'reminderfox-0.9.6.xpi'  by Daniel Lee, Tom Mutdosch
   */


/**
 * retrieve and display this reminder's associated email in Thunderbird 
 */
function reminderFox_openByMessageID(currentReminder){
	reminderFox_AddNewsServers();   

	// this function only works in ThunderBird - if using Firefox, throw up an alert message
    var appName = reminderFox_getAppName();   
    if(appName != "Thunderbird") {   	
    	alert( reminderFox_getBundle().getString("rf.add.mail.thunderbird.message") );
    	return;
    }

	var messageId = currentReminder.messageID;
	var summary = currentReminder.summary;
	var notes = currentReminder.notes;
	var hostname = "local"; 

 	if (messageId.substring(0,6) == "<mail>") {
             var hostname = "local";
      } 
 	if (messageId.substring(0,8) == "<google>")  {
             var hostname = "google.com";
      }

 	var midleft = (messageId.toLowerCase()).search("<"); 
 	var finalMessageId;
 	if (midleft == -1)
      	finalMessageId = "";
	else {
 	   var midRight = (messageId.substring(midleft)).search(">");
       finalMessageId =  messageId.substring(midleft + 1, midRight );
      }
	var port = "";
	
	if (finalMessageId !="" && hostname != "")  reminderFox_MessageIdFinder(hostname,port,finalMessageId);
}

/**
 * Add email reminder for current selected message
 */
function reminderFox_thunderBirdAddEmailReminder() {
	var remFoxSummary =  this.currentHeaderData.subject.headerValue;  
	var remFoxMessageID = this.currentHeaderData["message-id"].headerValue ;	
	var remFoxFrom = this.currentHeaderData.from.headerValue;
	var remFoxDate = this.currentHeaderData.date.headerValue;
	var datey =  this.currentHeaderData["date"].headerValue;
		
	var newDate = new Date();
	newDate.setDate( newDate.getDate() + 1 );

	var reminderId =reminderFox_generateUniqueReminderId( newDate );
	var mailIdentifierString = reminderFox_getBundle().getString("rf.add.mail.message.mail.identifier");
	var	newReminderToBeAdded = new ReminderFoxEvent( reminderId, newDate, mailIdentifierString + " " + remFoxSummary );
	newReminderToBeAdded.messageID = remFoxMessageID;

	// add default message header info to the Notes section
	newReminderToBeAdded.notes = reminderFox_getBundle().getString("rf.add.mail.message.sender")		+ ": "  + remFoxFrom + "\n" + 
		reminderFox_getBundle().getString("rf.add.mail.message.date")	+ ": " +  remFoxDate + "\n" + 
		reminderFox_getBundle().getString("rf.add.mail.message.subject")	+ ": " + remFoxSummary; 
		
	var newOptions = { reminder: newReminderToBeAdded, editing:  false,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"reminderOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addReminder ) {
		var currentDate = new Date();
		if ( newReminderToBeAdded.alarm != null ) {
			newReminderToBeAdded.alarmLastAcknowledge = currentDate.getTime();
		}
		newReminderToBeAdded.lastModified = reminderFox_getDateAsString(currentDate );
		
		// add reminder in sorted order...

		// add to edit reminder dialog if it is open
	   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");	 
	   if (topWindow) {
	   		var newDate = oeDatePicker.gSelectedDate;
			if ( newDate == null ) {
				newDate = new Date();
			}	
			var originalYear = newDate.getFullYear();
	   		// if adding a new reminder in a different year, first set the list/calendar to the new year 
			// before adding the reminder
			if ( originalYear != newReminderToBeAdded.date.getFullYear() ) {
			   	topWindow.oeDatePicker.gSelectedDate = newReminderToBeAdded.date;
				topWindow.repopulateListForYear( originalYear, newReminderToBeAdded.date.getFullYear() );
			}
	   	
	   		topWindow.focus();
	   		var reminders = topWindow.reminderFox_getReminderEvents();	
			var sortedIndex = topWindow.reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
			topWindow.reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
	   	
			topWindow.createListItem(newReminderToBeAdded);
			topWindow.oeDatePicker.onpopupshowing(newReminderToBeAdded.date);			
			topWindow.modifiedReminders();	
	   }		
	   else {
	   		// add reminder headlessly
	   		var reminders = reminderFox_getReminderEvents();	
			var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
			reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
	   }
		
		
		reminderFox_writeOutRemindersAndTodos(false);
		reminderFox_syncWrittenChangesToRemote(	);
		try {
			// update all of the browsers
			windowEnumerator =  reminderFox_getWindowEnumerator();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFoxEvents = reminderFoxEvents;
				currentWindow.reminderFoxTodos  = reminderFoxTodos;
				
				currentWindow.reminderFox_updateRemindersInWindow();			
				currentWindow.reminderFox_clearRemindersAndTodos();
			}
		}
		catch(e) {
		}				
	}			
}


function reminderFox_doShowMail() {
	var currentReminder = getReminderForSelectedItem( );
	reminderFox_openByMessageID(currentReminder);
}

function reminderFox_doShowMailTodo() {
	var currentTodo = getTodoForSelectedItem( );
	reminderFox_openByMessageID(currentTodo);	
}

function reminderFox_doShowMailShortcut() { 
	var remindersTab = document.getElementById("remindersTab");
	if ( remindersTab.selected ) {
		reminderFox_doShowMail();
	}
	else {
		reminderFox_doShowMailTodo();
	}
}


/*
 *  based on: MessageID-Finder for Mozilla 
 *
 *  Markus Hossner - markushossner@gmx.de
 *
 */

const reminderFox_pmpB = 0;
const reminderFox_pmpN = 1;
const reminderFox_pmpS = 2;

var reminderFox_prefRead = false;
var reminderFox_accountURIs = new Array();
var reminderFox_msgWindow;

/*
 *   Finds message via messageid
 */
function reminderFox_MessageIdFinder(strhostname,strport,strmessageid) {
    var openmsginnewwin = true;
	//var defaultnewsserver = "google.com";
    var defaultnewsserver = "none";   // change this to google to search for google groups messages

    // *** If strmessageid is empty, get messageid ****
    if (strmessageid == "") {        
        switch(document.firstChild.id) {
        
            // MessageID-Finder called within source view
            case "main-window":
                strmessageid = String(document.getElementById('content').contentWindow.getSelection());
                openmsginnewwin = true;
                break;

            // MessageID-Finder called within reminderFox_msgWindow
            case "messengerWindow":
                var source = document.popupNode.localName;
                
                switch(source) {
                    // MessageID-Finder called within message pane on selection
                    case "PRE":
                    case "DIV":
                        source = document.getElementById('messagepane');
                        strmessageid = String(source.contentWindow.getSelection());
                        break;

                    // MessageID-Finder called within message pane on link
                    case "A":
                        var linkText = gContextMenu.linkText();
                        
                        linkText = linkText.replace(/^<|>$/g, "");

                        // Workaround for Bug 89939
                        if (linkText.search(/news:[^\/]/) == 0) {
                            strmessageid  = linkText;
                        } else {
                            strmessageid = 'getLinkURL' in  gContextMenu ? gContextMenu.getLinkURL()
                                                                         : gContextMenu.linkURL();
                        }
                        break;

                    // MessageID-Finder called within message header
                    case "mail-emailaddress":
                        strmessageid = document.popupNode.getAttribute("sMID");
                        break;

                    default:
                        strmessageid = "";
                        break;
                }
                break;

            // MessageID-Finder called within Menulist of PrefDialog
            case "messageidfinderprefdialog":
            // MessageID-Finder called within Menulist of InputDialog
            case "midinputdialog":
            default:
                strmessageid = "";
                break;
        }
    }
    // ************************************************


    // *** Extract messageid ***
    if (strmessageid != "") strmessageid = reminderFox_ExtractMessageID(strmessageid);

    // *** Look for messageid ***
    var strsrc = "";
    
    if (strmessageid != "") {
        switch(strhostname) {
            // Look for MID locally
            case "local":
                var msgHdr = reminderFox_OpenMessageByMessageID(strmessageid);
                
                if (!msgHdr) {
                    if (defaultnewsserver == "none" || defaultnewsserver == null) {
                    	var strMsgIdNotFound = reminderFox_getBundle().getString("rf.add.mail.messageIdNotFound.message") +"\nMessage-ID: " + strmessageid;  
                        alert(strMsgIdNotFound);
                    } else if (defaultnewsserver.substring(0,6) == "google") {
                        reminderFox_MessageIdFinder(defaultnewsserver,"",strmessageid);
                    } else {
                        strhostname = reminderFox_pmpReadPref("mail.server." + defaultnewsserver + ".hostname",reminderFox_pmpS);
                        strport     = reminderFox_pmpReadPref("mail.server." + defaultnewsserver + ".port", reminderFox_pmpN);
                        
                        reminderFox_MessageIdFinder(strhostname,strport,strmessageid);
                    }
                }
                break;

            // Look for MID with googl.com / google.de
            case "google.com":
            case "google.de":
                strsrc = 'http://groups.' + strhostname + '/groups?selm=' +
                         escape(strmessageid) + '&rnum=1';
                break;

            // Look for MID with newsserver
            default:
                strsrc = 'news://' + strhostname + ':' + strport +'/'+ escape(strmessageid);
                break;
        }
    }
    // **************************
    

    // *** Open message ****
    if (strsrc.substring(0,4) == "news") {
        if (openmsginnewwin) {
            reminderFox_launchBrowser(strsrc);
        } else {
            var collapsedHeaderViewNode, expandedHeaderViewNode;
            
            if (document.firstChild.id == "messengerWindow") {
                collapsedHeaderViewNode = window.document.getElementById("collapsedHeaderView");
                expandedHeaderViewNode  = window.document.getElementById("expandedHeaderView");
                
                window.content.location = strsrc;
            } else {
                collapsedHeaderViewNode = window.opener.document.getElementById("collapsedHeaderView");
                expandedHeaderViewNode  = window.opener.document.getElementById("expandedHeaderView");
                
                window.opener.content.location = strsrc;
            }

            if (collapsedHeaderViewNode) collapsedHeaderViewNode.collapsed = true;
            if (expandedHeaderViewNode) expandedHeaderViewNode.collapsed = true;
        }
    } else if (strsrc.substring(0,4) == "http") {
        reminderFox_launchBrowser(strsrc);
    }
    // *********************
}

function reminderFox_getMsgWindow() {
	if ( reminderFox_msgWindow == null ) {
		reminderFox_msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"].createInstance(Components.interfaces.nsIMsgWindow);
	}
	return reminderFox_msgWindow;
}


function reminderFox_ExtractMessageID(strmessageid) {
    var midParts = strmessageid.replace(/^<|>$/g, "")
                               .split(":");

    switch (midParts.length) {
        case 1:
            strmessageid = strmessageid;
            break;

        case 2:
            if (midParts[0] == "news" || midParts[0] == "nntp") {
                strmessageid = midParts[1].replace(/^\/\/.*?\//,"");
            } else if (midParts[0] == "mailto") {
                strmessageid = midParts[1];
            }
            break;

        case 3:
            strmessageid = midParts[2].replace(/^.+?\//,"");
            break;

        default:
            strmessageid = "";
            break;
    }

    return strmessageid;
}


/*
 *   Opens and selects a message by messageid
 */
function reminderFox_OpenMessageByMessageID(messageId) {
   // var openmsginnewwin = reminderFox_pmpReadPref('extensions.messageidfinder.openmsginnewwin',reminderFox_pmpB);
     var openmsginnewwin = true;
    window.setCursor("wait");

    var msgHdr = reminderFox_SearchMessageLocally(messageId);
    
    if (msgHdr) {
        var folderUri = msgHdr.folder.URI;
        
        if (openmsginnewwin) {
            var folder = reminderFox_GetMsgFolderFromUri(folderUri);
            var messageUri = folder.getUriForMsg(msgHdr);
            
            window.openDialog("chrome://messenger/content/messageWindow.xul", "_blank",
                              "all,chrome,dialog=no,status,toolbar", messageUri, folderUri, null);
        } else {
            var tree = {};
            var msgDB = {};
            var length = {};
            var wintype = {};
            var msgDBView = {};
            var indicesArray = {};
            
            reminderFox_msgWindow = reminderFox_getMsgWindow();
            if (document.firstChild.id == "messengerWindow") {
                wintype = window.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window);
                
                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.gDBView;
                if (wintype != "mail:messageWindow") tree = window.GetThreadTree();
            } else {
                wintype = window.opener.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window.opener);

                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.opener.gDBView;
                if (wintype != "mail:messageWindow") tree = window.opener.GetThreadTree();
            }
            
            
            if (wintype != "mail:messageWindow") tree.view.selection.clearSelection();
            msgDBView.selectMsgByKey(msgHdr.messageKey);
            msgDBView.loadMessageByMsgKey(msgHdr.messageKey);
            msgDB.MarkHdrRead(msgHdr, true, null);
            msgDBView.getIndicesForSelection(indicesArray,length);
            if (wintype != "mail:messageWindow") tree.treeBoxObject
                                                     .ensureRowIsVisible(indicesArray.value[0]);
        }
    }

    window.setCursor("auto");
 
    return msgHdr;
}


/*
 *   Searchs for messageid in local folders
 */
function reminderFox_SearchMessageLocally(messageId) {
    var msgHdr = null;
    var folder = null;
    
    for(var x = 0; x < reminderFox_accountURIs.length && !msgHdr; x++) {
        folder = reminderFox_GetMsgFolderFromUri(reminderFox_accountURIs[x]).rootFolder;
        msgHdr = reminderFox_SearchInSubFolder(folder, messageId);
    }
    
    return msgHdr;
}


/*
 *   Searchs in subfolder
 */
function reminderFox_SearchInSubFolder(folder, messageId) {

    if (folder.hasSubFolders) {
        var subfolders = folder.GetSubFolders();
        var subfolder = null;
        var msgHdr = null;
        var msgDB = null;
        var currentFolderURI = "";

        var done = false;
        
        while(!done) {
            currentFolderURI = subfolders.currentItem()
                                         .QueryInterface(Components.interfaces.nsIRDFResource).Value;
            subfolder = reminderFox_GetMsgFolderFromUri(currentFolderURI);


            if (currentFolderURI.substring(1,7) != "news://") {
                msgHdr = reminderFox_SearchInSubFolder(subfolder, messageId);
            }
            if (!msgHdr) {
            
                try {

                	reminderFox_msgWindow = reminderFox_getMsgWindow();
                    msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
                } catch (ex) {

                 //   subfolder.updateFolder(reminderFox_msgWindow);     // TM: this call was causing a hang in some instances
//                    try {
//                 //  		 msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
//                   	 } catch (ex) {
//                   	 }
                }

                if ( msgDB != null ) {
               	 msgHdr = msgDB.getMsgHdrForMessageID(messageId);
                }
            }
            
            if (msgHdr) return msgHdr;
            
            
            try {
                subfolders.next();
            } catch(e) {
                done = true;
            }
        }
    }

    return null;
}


/*
 *   Searchs all availible newsserver
 */
function reminderFox_AddNewsServers() {
    if (reminderFox_prefRead == false) {
        var accounts = reminderFox_pmpReadPref("mail.accountmanager.accounts",reminderFox_pmpS);
        if (accounts) {
            var accountsArray = accounts.split(",");
            
            for (var x = 0; x < accountsArray.length; x++) {
                reminderFox_AddNewsServerMenuItem(accountsArray[x]);
            }
            reminderFox_accountURIs.sort(reminderFox_sortAccountUris);
        }

        reminderFox_prefRead = true;
    }
}


/*
 *   Sortfunction for reminderFox_accountURIs Array
 *   Local Folder to the rear
 */
function reminderFox_sortAccountUris(a, b) {

    if (a.search(/Local%20Folders/) != -1) {
        return 1;
    } else if (b.search(/Local%20Folders/) != -1) {
        return -1;
    } else if (a < b) {
        return -1;
    } else if (a > b) {
        return 1;
    } else {
        return 0;
    }
}


/*
 *   Adds newsserver to the context menu
 */
function reminderFox_AddNewsServerMenuItem(account) {
    var server    = reminderFox_pmpReadPref("mail.account." + account + ".server",reminderFox_pmpS);
    var servertyp = reminderFox_pmpReadPref("mail.server."  + server +  ".type",reminderFox_pmpS);
    var hostname  = reminderFox_pmpReadPref("mail.server."  + server +  ".hostname",reminderFox_pmpS);
    var username  = reminderFox_pmpReadPref("mail.server."  + server +  ".userName",reminderFox_pmpS);

    var accountURI = "";
    
    if (servertyp == "nntp") {
        var servername = reminderFox_pmpReadPref("mail.server." + server + ".name",reminderFox_pmpS);
        var serverport = reminderFox_pmpReadPref("mail.server." + server + ".port", reminderFox_pmpN);
        //var newsservermenuitem;

        if (servername == null) servername = hostname;
        if (serverport == null) serverport = 119;

//        newsservermenuitem = document.createElement("menuitem");
//        newsservermenuitem.setAttribute("label", servername);
//        newsservermenuitem.setAttribute("value",server);
//        newsservermenuitem.setAttribute("oncommand","reminderFox_MessageIdFinder('" +
//                                         hostname + "', '" + String(serverport) + "','');");

        accountURI = "news://" + escape(hostname);
    } else if (servertyp == "imap") {
        accountURI = "imap://" + escape(username) + "@" + escape(hostname);
    } else {
        accountURI = "mailbox://" + escape(username) + "@" + escape(hostname);
    }

    if (hostname != null) reminderFox_accountURIs.push(accountURI);
}



/*
 *   Reads the value of pmpName out of the mozilla preferences
 */
function reminderFox_pmpReadPref(pmpName, pmpType) {
    var nsIPrefBranch = Components.interfaces.nsIPrefBranch;
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(nsIPrefBranch);
    var pmpValue = null;
    
    if (pref.prefHasUserValue(pmpName)) {
        switch (pmpType) {
            case reminderFox_pmpB:
                pmpValue = pref.getBoolPref(pmpName);
                break;
            case reminderFox_pmpN:
                pmpValue = pref.getIntPref(pmpName);            
                break;
            case reminderFox_pmpS:
                pmpValue = pref.getCharPref(pmpName);
                break;
            default:
                break;
        }
    }
    
    return pmpValue;
}


/*
 *   Get msgfolder from Uri
 */
function reminderFox_GetMsgFolderFromUri(uri) {
    var msgfolder = null;
    
    try {
        var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
        var resource = RDF.GetResource(uri);
        
        if (resource instanceof Components.interfaces.nsIMsgFolder &&
           (resource.parent || resource.isServer))
           msgfolder = resource;
           
    } catch (ex) {}

    return msgfolder;
}


function reminderFox_getAppName() {
    var appName = "Mozilla Suite";
    
    try {
        var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                                .getService(Components.interfaces.nsIXULAppInfo);
        appName = appInfo.name;
    } catch(ex) {}
    
    return appName;
}


function reminderFox_launchBrowser(UrlToGoTo) {
    var appName = reminderFox_getAppName();
    
    if(appName == "Thunderbird") {
        var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance()
                                  .QueryInterface(Components.interfaces.nsIMessenger);
                                  
        messenger.launchExternalURL(UrlToGoTo);
        
    } else if (appName == "SeaMonkey" || appName == "Mozilla Suite") {
        var navWindow;
        
        // Try to get the most recently used browser window
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                               .getService(Components.interfaces.nsIWindowMediator);
            navWindow = wm.getMostRecentWindow("navigator:browser");
        } catch(ex) {}
        
        if (navWindow) {  // Open the URL in most recently used browser window
            if ("delayedOpenTab" in navWindow) {
                navWindow.delayedOpenTab(UrlToGoTo);
            } else if ("loadURI" in navWindow) {
                navWindow.loadURI(UrlToGoTo);
            } else {
                navWindow._content.location.href = UrlToGoTo;
            }
        } else {  // If there is no recently used browser window open new browser window with the URL
            var ass = Components.classes["@mozilla.org/appshell/appShellService;1"]
                                .getService(Components.interfaces.nsIAppShellService);
            var win = ass.hiddenDOMWindow;
            
            win.openDialog("chrome://navigator/content/navigator.xul", "",
                           "chrome,all, dialog=no", UrlToGoTo );
        }
     
    }
}
